var wtf = angular.module('starter', ['ionic', 'starter.controllers', 'pascalprecht.translate', 'monospaced.elastic', 'pasvaz.bindonce']);
var wtfCtrls = angular.module('starter.controllers', []);

wtf.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    if(window.StatusBar) {
      StatusBar.styleDefault();
    }
    // Platform.fullScreen(true,true);
  });
})

// https://github.com/angular-ui/ui-router/wiki
.config(function($stateProvider, $urlRouterProvider, $httpProvider, $translateProvider, msdElasticConfig) {

  //http://victorblog.com/2012/12/20/make-angularjs-http-service-behave-like-jquery-ajax/
  $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';

  /**
   * The workhorse; converts an object to x-www-form-urlencoded serialization.
   * @param {Object} obj
   * @return {String}
   */ 
  var param = function(obj) {
    var query = '', name, value, fullSubName, subName, subValue, innerObj, i;
      
    for(name in obj) {
      value = obj[name];
        
      if(value instanceof Array) {
        for(i=0; i<value.length; ++i) {
          subValue = value[i];
          fullSubName = name + '[' + i + ']';
          innerObj = {};
          innerObj[fullSubName] = subValue;
          query += param(innerObj) + '&';
        }
      }
      else if(value instanceof Object) {
        for(subName in value) {
          subValue = value[subName];
          fullSubName = name + '[' + subName + ']';
          innerObj = {};
          innerObj[fullSubName] = subValue;
          query += param(innerObj) + '&';
        }
      }
      else if(value !== undefined && value !== null)
        query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
    }
      
    return query.length ? query.substr(0, query.length - 1) : query;
  };
 
  // Override $http service's default transformRequest
  $httpProvider.defaults.transformRequest = [function(data) {
    return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
  }];

  msdElasticConfig.append = '\n\n';

  $translateProvider
    .useStaticFilesLoader({
        prefix: 'resources/languages/',
        suffix: '.json'
    });


  $stateProvider
    .state('app', {
      url: "/app",
      abstract: true,
      templateUrl: "templates/menu.html",
      controller: 'AppCtrl',
      resolve: {
        p: function(Preferences) {
          return Preferences.init();
        }
      }
    })

    .state('app.login', {
      url: "/login",
      views: {
        'menuContent' :{
            templateUrl: "templates/user/login.html",
            controller: "LoginCtrl"
        }
      }
    })

    .state('app.createAccount', {
      url: "/create-account",
      views: {
        'menuContent' :{

          templateUrl: "templates/user/create-account.html",
          controller: "CreateAccountCtrl"
        }
      }
    })

    .state('app.preferencesIndex', {
      url: "/preferences/index",
      views: {
        'menuContent' :{
          templateUrl: "templates/preferences/index.html",
          controller: 'PreferenceIndexCtrl'
        }
      }
    })

    .state('app.inflightIndex', {
      url: "/inflight/index",
      views: {
        'menuContent' :{
          templateUrl: "templates/inflight/list.html",
          controller: 'InflightListCtrl'
        }
      }
    })

    .state('app.inflightCreate', {
      url: "/inflight/review-create",
      views: {
        'menuContent' :{
          templateUrl: "templates/inflight/create.html",
          controller: 'InflightCreateCtrl'
        }
      }
    })
    
    .state('app.inflightReview', {
      url: "/inflight/review/:id",
      views: {
        'menuContent' :{
          templateUrl: "templates/inflight/item.html",
          controller: 'InflightItemCtrl'
        }
      }
    })
     

    .state('app.inflightChooseAirline', {
      url: "/inflight/review/:id/chooseAirline/:airlineId",
      views: {
        'menuContent' :{
          templateUrl: "templates/inflight/choose-airline.html",
          controller: 'InflightChooseAirlineCtrl'
        }
      }
    })

    .state('app.inflightChooseAirport', {
      url: "/inflight/review/:id/chooseAirport/:type/:airportId",
      views: {
        'menuContent' :{
          templateUrl: "templates/inflight/choose-airport.html",
          controller: 'InflightChooseAirportCtrl'
        }
      }
    })

    .state('app.inflightPicture', {
      url: "/inflight/review/:id/picture/:pictureId",
      views: {
        'menuContent' :{
          templateUrl: "templates/inflight/picture.html",
          controller: 'InflightPictureCtrl'
        }
      }
    });

  $urlRouterProvider.otherwise('app/inflight/index');
});