wtfCtrls.controller('CreateAccountCtrl', function($scope, $window, $rootScope, $ionicLoading, $location, $translate, Preferences, ServiceUserCreateAccount) {
	$scope.view = {};
	$scope.view.showAccepted = Preferences.get('termsAccepted') != 'true';
	$scope.view.accepted = !$scope.view.showAccepted;	

	$scope.view.hasKeyboard = false;
	$scope.view.keyboardHeight = 200;


	$window.addEventListener('native.showkeyboard', function(e){
		$scope.view.hasKeyboard = true;
		$scope.view.keyboardHeight = e.keyboardHeight;
		$scope.$apply();
	});
	
	$window.addEventListener('native.hidekeyboard', function(e){
		$scope.view.hasKeyboard = false;
		$scope.$apply();
	});

	$scope.openTerms = function() {
    	$translate('CONDITIONS_URL').then(function(url) {
    		window.open(encodeURI(url), '_system', 'location=yes');
    	});      
    }

	$scope.signUp = function() {
		$ionicLoading.show({
			template: '<span class="icon ion-loading-c"></span> '+Preferences.translate('SIGN_UP_LOADING')
		});
		
		$scope.view.errorString = '';

		ServiceUserCreateAccount.run($scope.view.pseudo, $scope.view.email, $scope.view.password).then(function(json) {	
			if (json.success) {
				Preferences.set('user_connected', 'true').then(function() {
					Preferences.set('email', $scope.view.email).then(function() {
						Preferences.set('user_id', json.data.id).then(function() {
							Preferences.set('user_key', json.data.key).then(function() {
								Preferences.set('termsAccepted', 'true').then(function() {
									$ionicLoading.hide();

									$rootScope.$emit('login');	

									$location.url('/app/inflight/index');	
								});
							});
						});
					});
				});
			} else {
				$ionicLoading.hide();
				$scope.view.errorString = json.errorString;
			}
		}, function() {
			$scope.view.errorString = Preferences.translate('UNEXPECTED_ERROR');	
			$ionicLoading.hide();
		});
	}
});