wtfCtrls.controller('InflightItemCtrl', function($ionicLoading, $translate, $window, $scope, $ionicScrollDelegate, $location, $stateParams, $ionicModal, $location, $ionicPopup, Preferences, TakePicture, DatabaseCreateAirlineReview, DatabaseGetAirlineReviews, PublishAirlineReview, DatabaseGetAirlineReview, DatabaseUpdateAirlineReview, DatabaseGetReviewPictures, DatabaseCreateReviewPicture, DatabaseUpdateReviewPicture, DatabaseDeleteReviewPicture, DatabaseGetDefaultAirlines, DatabaseGetAirlines, DatabaseGetAirports, DatabaseGetDefaultAirports) {
	var id = $stateParams.id;
	$scope.view = {};
	$scope.view.showPictureDelete = false;
	$scope.view.initialized = false;
	$scope.view.isUpdate = false;
	$scope.view.showAccepted = Preferences.get('termsAccepted') != 'true';
	$scope.view.accepted = !$scope.view.showAccepted;	
	
	$ionicLoading.show({
      template: '<span class="icon ion-loading-c"></span>'
    });

    $scope.openTerms = function() {
    	$translate('CONDITIONS_URL').then(function(url) {
    		window.open(encodeURI(url), '_system', 'location=yes');
    	});      
    }
	
	DatabaseGetAirlineReview.run(id).then(function(item) {
		$scope.airlineReview = item;
		$scope.view.disabled = $scope.airlineReview.status > 0;
		$scope.view.isUpdate = $scope.airlineReview.status != -1;

		var h = Preferences.get('inflight.item.'+id+'.scroll');
		$ionicScrollDelegate.scrollTo(0, isNaN(h) ? 0 : h, false);

		var o = {};
		o.includeAll = false;
		DatabaseGetReviewPictures.runForAirlineReview(item, o).then(function(pictures) {
			$scope.pictures = pictures;
			$scope.view.initialized = true;
			$ionicLoading.hide();	
		});
	});

	$scope.changeStatus = function() {
		DatabaseUpdateAirlineReview.run($scope.airlineReview.id, {status: 0}).then(function() {
			$scope.view.isUpdate = true;
			$scope.airlineReview.validation.flightInfo = true;
		});
	}

	$scope.managePictureDelete = function() {
		$scope.view.showPictureReorder = false;
		$scope.view.showPictureDelete = !$scope.view.showPictureDelete;
	}

	$scope.managePictureReorder = function() {
		$scope.view.showPictureDelete = false;
		$scope.view.showPictureReorder = !$scope.view.showPictureReorder;
	}

	$scope.chooseAirline = function() {
		if ($scope.view.disabled) return;

		$ionicModal.fromTemplateUrl('templates/inflight/choose-airline.html', {
			scope: $scope,
		    animation: 'slide-in-up'
		}).then(function(modal) {
		    $scope.modal = modal;
		    $scope.modal.show();
		    

		    $scope.seachModel = {};
			$scope.seachModel.q = '';
			$scope.seachModel.searching = false;
			$scope.airlines = [];

			$scope.searchAirline = function() {
				$scope.seachModel.searching = true;

				var options = {pageNum: 1, perPage: 20, q: $scope.seachModel.q};
				DatabaseGetAirlines.run(options).then(function(airlines) {
					$scope.airlines = airlines;

					$ionicScrollDelegate.$getByHandle('chooseAirlinsScroll').scrollTop();
					$scope.seachModel.searching = false;
				})
			}

			$scope.submitAirline = function(airline) {
				$scope.airlineReview.airline = airline;
				
				DatabaseUpdateAirlineReview.run($scope.airlineReview.id, {airline_id: airline.id}).then(function() {
					$scope.modal.remove();
				});
			}

			if ($scope.airlineReview.airline.id > 0) {
				$scope.seachModel.q = $scope.airlineReview.airline.name;
				$scope.searchAirline();
			} else {
				$scope.seachModel.searching = true;
				DatabaseGetDefaultAirlines.run().then(function(airlines) {
					$scope.airlines = airlines;
					$scope.seachModel.searching = false;
				});
			}
		});
	}

	$scope.chooseAirport = function(type) {
		if ($scope.view.disabled) return;

		$ionicModal.fromTemplateUrl('templates/inflight/choose-airport.html', {
			scope: $scope,
		    animation: 'slide-in-up'
		}).then(function(modal) {
		    $scope.modal = modal;
		    $scope.modal.show();

		    $scope.seachModel = {};
			$scope.seachModel.q = '';
			$scope.seachModel.searching = false;

			$scope.airports = [];


			var camel = '';
			switch (type) {
				case 'departure_airport':
					camel = 'departureAirport';
				break;
				case 'arrival_airport':
					camel = 'arrivalAirport';
				break;
			}

			$scope.searchAirport = function() {
				$scope.seachModel.searching = true;
				var options = {pageNum: 1, perPage: 20, q: $scope.seachModel.q};
				DatabaseGetAirports.run(options).then(function(airports) {
					$scope.airports = airports;

					$ionicScrollDelegate.$getByHandle('chooseAirportScroll').scrollTop();

					$scope.seachModel.searching = false;
				})
			}

			$scope.submitAirport = function(airport) {
				$scope.airlineReview[camel] = airport;

				var o = {};
				o[type+'_id'] = airport.id;
				DatabaseUpdateAirlineReview.run($scope.airlineReview.id, o).then(function() {
					$scope.modal.hide();
				});
			}

			if ($scope.airlineReview[camel].id > 0) {
				$scope.seachModel.q = $scope.airlineReview[camel].name;
				$scope.searchAirport();
			} else {
				$scope.seachModel.searching = true;
				DatabaseGetDefaultAirports.run().then(function(airports) {
					$scope.airports = airports;
					$scope.seachModel.searching = false;
				});
			}
		});
	}

	$scope.view.keyboardHeight = 200;
	$scope.view.showOk = false;
	$window.addEventListener('native.showkeyboard', function(e){
		$scope.view.showOk = true;
		$scope.view.keyboardHeight = e.keyboardHeight;
		$scope.$apply();
	});
	
	$window.addEventListener('native.hidekeyboard', function(e){
		$scope.view.showOk = false;
		$scope.$apply();
	});
	
	$scope.save = function(attr) {
		var o = {};
		o[attr] =  $scope.airlineReview[attr];
		DatabaseUpdateAirlineReview.run(id, o).then();

		$scope.airlineReview.validation.texts = !!($scope.airlineReview.title && $scope.airlineReview.text && $scope.airlineReview.title.length > 1 && $scope.airlineReview.text.length > 150);
		$scope.airlineReview.validation.ratings = !!($scope.airlineReview.rate_global > 0 && $scope.airlineReview.rate_value > 0);
		$scope.airlineReview.validation.pictures = !!($scope.airlineReview.picture.file);
		$scope.airlineReview.validation.all = $scope.airlineReview.validation.texts && $scope.airlineReview.validation.ratings && $scope.airlineReview.validation.pictures;
	}

	$scope.deletePicture = function(item, index) {
		$ionicPopup.confirm({
       		title: Preferences.translate('CONFIRM_DELETE'),
       		template: Preferences.translate('ARE_YOU_SURE'),
       		cancelText: Preferences.translate('CANCEL'),
       		okText: Preferences.translate('OK')
     	}).then(function(res) {
	       	if(!res) return;

			DatabaseDeleteReviewPicture.run(item).then(function() {
				$scope.pictures.splice(index, 1);
			
				if (item.id == $scope.airlineReview.favorite_picture_id && $scope.pictures.length > 0) {
					$scope.airlineReview.favorite_picture_id = $scope.pictures[$scope.pictures.length - 1].id;

					var o = {};
					o.favorite_picture_id = $scope.pictures[$scope.pictures.length - 1].id;
					DatabaseUpdateAirlineReview.run(id, o).then(function() {});
				} 
			});			
	    });
	}

	var counter = 0;
	$scope.movePicture = function(item, fromIndex, toIndex) {
	 	$scope.pictures.splice(fromIndex, 1);
  		$scope.pictures.splice(toIndex, 0, item);

  		counter = 0;

  		function updateOrder() {
			var len = $scope.pictures.length;
			if (counter > len) return;

			var o = {};
	   	 	o.display_order = counter + 1;
	   	 	
			DatabaseUpdateReviewPicture.run($scope.pictures[counter].id, o).then(function() {
				counter++;
	   	 		updateOrder();
	   	 	});
		}

  		updateOrder();
	}

	$scope.$on('$destroy', function() {
		if ($scope.modal) {
	   	 	$scope.modal.remove();
	    }
	    Preferences.set('inflight.item.'+id+'.scroll', parseInt($ionicScrollDelegate.$getByHandle('mainScroll').getScrollPosition().top));
	});

	$scope.takePicture = function(from) {
		$scope.view.showPictureReorder = false;
		$scope.view.showPictureDelete = false;

		TakePicture.run(id, from).then(function(item) {
			$location.path('/app/inflight/review/'+id+'/picture/'+item.id);
		});
	}

	$scope.scroll = function(id) {  
		$location.hash(id);
		$ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll(true);
	}

	$scope.publish = function() {
		Preferences.set('termsAccepted', 'true');

		$ionicPopup.confirm({
       		title: Preferences.translate('CONFIRM_PUBLICATION'),
       		template: Preferences.translate('ARE_YOU_SURE_PUBLICATION'),
       		cancelText: Preferences.translate('CANCEL'),
       		okText: Preferences.translate('OK')
     	}).then(function(res) {
	       	if(!res) return;
			
			$ionicLoading.show({
				template: '<span class="icon ion-loading-c"></span> '+Preferences.translate('PUBLISHING_LOADING')
			});

			PublishAirlineReview.run($scope.airlineReview).then(function() {
				$ionicLoading.hide();
				$location.path('/app/inflight/index');
			}, function() {
				$ionicLoading.hide();
				$location.path('/app/inflight/index');	
			}, function(message) {
				$ionicLoading.show({
					template: '<span class="icon ion-loading-c"></span> '+message
				});
			});	
	    });		
	}
})