wtfCtrls.controller('InflightListCtrl', function($scope, $rootScope, $ionicPopup, $ionicModal, $location, $ionicLoading, $ionicViewService, Preferences, DatabaseGetCreationAirlineReview, PublishAirlineReview, DatabaseGetAirlineReviews, DatabaseDeleteAirlineReview) {
	//$ionicViewService.clearHistory();


	if (!Preferences.get('intro.main.watch')) {
		$ionicModal.fromTemplateUrl('templates/intro.html', {
	    	scope: $scope,
	    	animation: 'slide-in-up'
	 	}).then(function(modal) {
	    	$scope.modal = modal;
	    	$scope.modal.show();
	  	}); 

	  	$scope.createFirstFlight = function() {
			Preferences.set('intro.main.watch', true)
			$scope.modal.hide();

			DatabaseGetCreationAirlineReview.run().then(function(item) {
				$location.path('/app/inflight/review/'+item.id);	
			});
		}
 	}

	$scope.$on("$destroy", function(){
		if ($scope.modal) {
			$scope.modal.hide();
		}

		document.removeEventListener("offline", onOffline, false);
		document.removeEventListener("online", onOnline, false);
	});

	$ionicLoading.show({
      template: '<span class="icon ion-loading-c"></span>'
    });

	$scope.view = {};
	$scope.view.initialized = false;
	$scope.view.hasInternet = Preferences.hasInternetConnection();
	// $scope.view.prompt = false;

	var onOffline = function() {
		$scope.view.hasInternet = false;
		$scope.$apply();
	}

	var onOnline = function() {
		promptPendingReviews();

		$scope.view.hasInternet = true;
		$scope.$apply();
	}

	document.addEventListener("offline", onOffline, false);
	document.addEventListener("online", onOnline, false);
	
	function promptPendingReviews() {
		if (Preferences.hasInternetConnection() && $scope.pendingReviews && $scope.pendingReviews.length > 0) {
			document.removeEventListener("online", onOnline, false);

			$ionicPopup.confirm({
	       		title: Preferences.translate('CONFIRM_PUBLISH_INTERNET_TITLE'),
	       		template: Preferences.translate('CONFIRM_PUBLISH_INTERNET_DESCRIPTION'),
	       		cancelText: Preferences.translate('CANCEL'),
	       		okText: Preferences.translate('OK')
	     	}).then(function(res) {
	     		document.addEventListener("online", onOnline, false);
		       	if(!res) return;
				$rootScope.$emit('uploadAll');		
		    });

		}
	}

	$scope.uploadAll = function() {
		promptPendingReviews();
	}

	$rootScope.$on('refreshList', getReviews);

	function getReviews() {
		$scope.inCreationReview = null;
		DatabaseGetCreationAirlineReview.run().then(function(item) {
			$scope.inCreationReview = item;

			DatabaseGetAirlineReviews.run({where: 'airline_review.status != -1'}).then(function(allReviews) {
				var r1 = [];
				var r2 = [];
				var r3 = [];

				var len = allReviews.length;
				for (var i = 0; i < len; i++) {
					var r = allReviews[i];
					if (r.status == 0) {
						r1.push(r);
					} else if (r.status == 3) {
						r3.push(r);
					} else {
						r2.push(r);
					}
				}

				$scope.view.initialized = true;
				$scope.reviews = r1;
				$scope.pendingReviews = r2;
				$scope.publishedReviews = r3;

				if (r2.length > 0) {
					window.plugin.notification.local.isScheduled(1, function (isScheduled) { 
						if (isScheduled) return;

						var now                  = new Date().getTime();
						var _30_seconds_from_now = new Date(now + 30*1000);

						window.plugin.notification.local.add({
						    id:     	1,
						    title:  	Preferences.translate('REMINDER_TITLE'),
						    message: 	Preferences.translate('REMINDER_DESCRIPTION'),
						    repeat: 	'daily',
						    date:   	_30_seconds_from_now,
						    badge:  	r2.length,
						    autoCancel: true 
						});
					});
				} else {
					window.plugin.notification.local.cancel(1, function() {});
				}

				$ionicLoading.hide();

				promptPendingReviews();
			}, function() {
				$ionicLoading.hide();
			});
		});		
	}
	
	getReviews();
	
	$scope.getIcon = function(review) {
		switch (review.status) {
			case 1:
				return 'ion-load-c';
			break;
			case 2:
			case 4:
				return 'ion-loading-c';
			break;
			case 3:
				return 'ion-checkmark';
			break;
		}
	}

	$scope.delete = function(item, index, listName) {	
     	$ionicPopup.confirm({
       		title: Preferences.translate('CONFIRM_DELETE'),
       		template: Preferences.translate('ARE_YOU_SURE'),
       		cancelText: Preferences.translate('CANCEL'),
       		okText: Preferences.translate('OK')
     	}).then(function(res) {
	       	if(!res) return;
       		DatabaseDeleteAirlineReview.run(item).then(function() {
				// $scope.reviews.splice(index, 1);
				$scope[listName].splice(index, 1);
			});	
	    });
	}
});