wtfCtrls.controller('InflightPictureCtrl', function($scope, $window, $ionicLoading, $stateParams, $location, TakePicture, DatabaseGetReviewPicture, DatabaseUpdateReviewPicture, DatabaseGetAirlineReview, DatabaseUpdateAirlineReview) {
	var pictureId = $stateParams.pictureId;
	var id = $stateParams.id;

	$scope.view = {};
	$scope.view.disabled = false;
	$scope.view.initialized = false;
	$scope.view.showOk = false;

	$ionicLoading.show({
      template: '<span class="icon ion-loading-c"></span>'
    });

	DatabaseGetReviewPicture.run(pictureId).then(function(item) {
		$scope.picture = item;

		DatabaseGetAirlineReview.run(id).then(function(review) {
			$scope.view.disabled = review.status > 0;
			$scope.view.initialized = true;

			$ionicLoading.hide();

			if (!review.picture.file) {
				var o = {};
				o.favorite_picture_id = $scope.picture.id;
				DatabaseUpdateAirlineReview.run(id, o).then(function() {});
			}
		});
	});

	function onShowKeyboard() {
		$scope.view.showOk = true;
		$scope.$apply();
	}
	
	function onHideKeyboard() {
		$scope.view.showOk = false;
		$scope.$apply();
	}

	$window.addEventListener('native.showkeyboard', onShowKeyboard, false);
	$window.addEventListener('native.hidekeyboard', onHideKeyboard, false);

	$scope.$on("$destroy", function(){
		$window.removeEventListener('native.showkeyboard', onShowKeyboard, false);
		$window.removeEventListener('native.hidekeyboard', onHideKeyboard, false);
	});

	$scope.save = function(attr) {
		var o = {};
		o[attr] =  $scope.picture[attr];
		DatabaseUpdateReviewPicture.run(pictureId, o).then();
	}

	$scope.takePicture = function(from) {
		TakePicture.run(id, from).then(function(item) {
			$location.path('/app/inflight/review/'+id+'/picture/'+item.id);
		});
	}
});