wtfCtrls.controller('LoginCtrl', function($scope, $rootScope, $location, $ionicPopup, $ionicLoading, Preferences, ServiceUserLogin) {
	$scope.view = {};
	$scope.view.loading = false;

	$scope.signIn = function() {
		$ionicLoading.show({
			template: '<span class="icon ion-loading-c"></span> '+Preferences.translate('SIGN_IN_LOADING')
		});

		$scope.view.errorString = '';

		ServiceUserLogin.run($scope.view.email, $scope.view.password).then(function(json) {
			if (json.success) {
				Preferences.set('user_connected', 'true').then(function() {
					Preferences.set('email', $scope.view.email).then(function() {
						Preferences.set('user_id', json.data.id).then(function() {
							Preferences.set('user_key', json.data.key).then(function() {
								$ionicLoading.hide();

								$rootScope.$emit('login');	

								$location.url('/app/inflight/index');	
							});
						});
					});
				});
			} else {
				$ionicLoading.hide();
				$scope.view.errorString = json.errorString;
			}
		}, function(raw) {
			$scope.view.errorString = Preferences.translate('UNEXPECTED_ERROR');
			$ionicLoading.hide();
		});
	}

	$scope.showForgotPassword = function() {
		$ionicPopup.show({
     		template: '<input type="email" required ng-model="view.email">',
     		title: Preferences.translate('PASSWORD_FORGOTTEN'),
     		scope: $scope,
     		buttons: [
       			{ text: Preferences.translate('CANCEL') },
       			{
         			text: '<b>'+Preferences.translate('OK')+'</b>',
         			type: 'button-positive',
         			onTap: function(e) {
           				if (!$scope.view.email) {
             				e.preventDefault();
             				return false;
           				} else {
             				return true;
           				}
         			}
       			},
     		]
   		}).then(function(res) {
   			if (!res) return;
   			$ionicLoading.show({
		      template: 'Sending email...'
		    });

		    setTimeout(function() {
		    	$ionicLoading.hide();
		    }, 4000);
   		});
	}
});