wtfCtrls.directive('datePicker', function($ionicModal) {
	return {
		scope: false,
 		transclude: false,
		link: function(scope, element, attrs) { 
			scope.dateDirective = {};

			$ionicModal.fromTemplateUrl('templates/date-picker.html', {
		    	scope: scope,
		    	animation: 'slide-in-up'
		 	}).then(function(modal) {
		    	scope.dateDirective.modal = modal;
		  	});

		  	scope.$on('$destroy', function() {
				if (scope.dateDirective.modal) {
			   	 	scope.dateDirective.modal.remove();
			    }
			    display.unbind('click');
			    listener();
			});

		 	element[0].style.display = "none";

		 	var wrapper = angular.element('<div>');
		 	wrapper.css({width: '100%'});
            element.wrap(wrapper);

            var str = '<div>&nbsp;</div>';
            var display = angular.element(str);
            display.css({width: '100%'});
            element.after(display);


		  	display.bind('click', function(event) {
		  		if (element.attr('disabled')) return;

		  		scope.dateDirective.modal.show();
		  		if (!scope.day) {
		    		var date = new Date();
				  	scope.year = date.getFullYear();
		            scope.month = date.getMonth() + 1;
		            scope.monthStr = formatMonth(scope.month);
		            scope.day = date.getDate();
		    	}
		  	});

		  	scope.dayUp = function() {
		  		scope.day++;
		  		if (scope.day > 31) {
		  			scope.day = 1;
		  		}
		  	}

		  	scope.dayDown = function() {
		  		scope.day--;
		  		if (scope.day < 1) {
		  			scope.day = 31;
		  		}
		  	}

		  	scope.monthUp = function() {
		  		scope.month++;
		  		if (scope.month > 12) {
		  			scope.month = 1;
		  		}

		  		scope.monthStr = formatMonth(scope.month);
		  	}

		  	scope.monthDown = function() {
		  		scope.month--;
		  		if (scope.month <= 0) {
		  			scope.month = 12;
		  		}

		  		scope.monthStr = formatMonth(scope.month);
		  	}	

		  	scope.yearUp = function() {
		  		scope.year++;
		  	}

		  	scope.yearDown = function() {
		  		scope.year--;
		  	}	

		  	scope.saveDate = function() {
				scope.airlineReview.departure_date = scope.year+'-'+formatVal(scope.month)+'-'+formatVal(scope.day);
				scope.save('departure_date');

				updateDisplay();

                scope.dateDirective.modal.hide();
			}


			function formatVal(i) {
				return i < 10 ? '0'+i : i;
			}

			function updateDisplay() {
				 display.html( formatVal(scope.day) + ' ' + formatMonth(scope.month) + ' ' + scope.year);
			}

		  	var go =  true;
			var listener = scope.$watch(function() {
				if (!go) return;

				var value = element.val();
				var sp = value ? value.split('-') : [];
				
	            if (sp.length == 3) {
	            	go = false;
		            scope.year = parseInt(sp[0]);
		            scope.month = parseInt(sp[1]);
		            scope.monthStr = formatMonth(scope.month);
		            scope.day = parseInt(sp[2]);

		           	updateDisplay();
				} 
			},function() {});  	
        }
    }
});