wtfCtrls.directive('ratePicker', function($ionicModal, $translate) {
	return {
		scope: false,
 		transclude: false,
		link: function(scope, element, attrs) { 

			var type = element.attr('rate-picker');
			var typeUpper = element.attr('rate-picker').toUpperCase();

			var modal = undefined;
			var select = undefined;
			var button = undefined;
			var title = undefined;
			var description = undefined;
			var options = undefined;

			$ionicModal.fromTemplateUrl('templates/rate-picker.html', {
		    	scope: scope,
		    	animation: 'slide-in-up'
		 	}).then(function(m) {
		    	modal = m;
		  		select = modal.$el.find('select');
				button = modal.$el.find('button');
				title = modal.$el.find('label');

				description = modal.$el.find('p');
				options = modal.$el.find('option');

				button.bind('click', function() {
					scope.airlineReview[type] = select.val();
					scope.save(type);

					updateDisplay(select.val());
	                modal.hide();
				});

				if (element.attr('has-not-applicable') === 'false') {
					angular.element(options[0]).remove();
					if (select.val() == '') {
						select.val(3);
					}
				}
	
				$translate(typeUpper).then(function(value) {
					title.text(value);
				});

				$translate(typeUpper+'_DESCRIPTION').then(function(value) {
					description.text(value);
				})
		  	}); 

		  	scope.$on('$destroy', function() {
				if (modal) {
			   	 	modal.remove();
			    }
			    display.unbind('click');
			    listener();
			});


			element[0].style.display = "none";
          	element.wrap('<div>');


            var str = '<div>&nbsp;</div>';
            var display = angular.element(str);
            display.css({position: 'absolute', right:'0px', top: '0px', minWidth: '100%', padding:'12px', textAlign:'right'}); // 
            element.after(display);

            display.bind('click', function(event) {
		  		if (element.attr('disabled')) return;

		  		if (element.attr('has-not-applicable') === 'false') {
		  			if (element.val() == '') { 
		  				select.val(3)
		  			} else {
		  				select.val(element.val())
		  			}
		  		} else {
		  			select.val(element.val())
		  		}

		  		modal.show();		  		
		  	});

		  	

            function updateDisplay(val) {
            	if (val > 0) {
            		var str = '';
            		for (var i = 0; i < val; i++) {
            			str += '<i class="icon ion-ios7-star"></i>';
            		}
            		for (var i = val; i < 5; i++) {
            			str += '<i class="icon ion-ios7-star-outline"></i>';
            		}
            		
            		display.html(str);
            	} else {
            		display.html('&nbsp;');
            	}
			}

			var listener = scope.$watch(function() {
		       	updateDisplay(element.val());
			},function() {});  	

		}
	}
})