wtf.factory('DatabaseGetAirlineReview', function(Preferences, $q) {
  		var f = {};
  		
		function errorCB(err) {
			// console.log("Error processing SQL: "+err.code);
			// console.log(err);

			f.deferred.reject(err);
		}

		function queryDB(tx) {
			var sql = 	'	SELECT '+
	    				'		airline.name AS airline_name, '+
	    				'		departure_airport.name AS departure_airport_name, '+
	    				'		arrival_airport.name AS arrival_airport_name, '+
	    				' 		review_picture.id AS review_picture_id, '+
	    				'		review_picture.file AS review_picture_file, '+	    				
	    				'		airline_review.*, '+
	    				'		datetime(airline_review.creation_date, \'localtime\') AS creation_date' +
	    				'	FROM airline_review airline_review '+
	    				'	LEFT JOIN airline airline '+
	    				'		ON airline.id = airline_review.airline_id '+
	    				'	LEFT JOIN review_picture review_picture '+
	    				' 		ON review_picture.id = airline_review.favorite_picture_id'+
	    				'	LEFT JOIN airport departure_airport '+
	    				'		ON departure_airport.id = airline_review.departure_airport_id'+
	    		    	'	LEFT JOIN airport arrival_airport '+
	    				'		ON arrival_airport.id = airline_review.arrival_airport_id'+				
	    				'	WHERE airline_review.id = '+f.id;
		
		    tx.executeSql(sql, [], querySuccess, errorCB);
		}

		function querySuccess(tx, results) {
			var rows = results.rows;
			var item = rows.item(0);

			var clone = angular.copy(item);

			clone.airline = {};
			clone.airline.id = clone.airline_id;
			clone.airline.name = clone.airline_name;

			clone.departureAirport = {};
			clone.departureAirport.id = clone.departure_airport_id;
			clone.departureAirport.name = clone.departure_airport_name;

			clone.arrivalAirport = {};
			clone.arrivalAirport.id = clone.arrival_airport_id;
			clone.arrivalAirport.name = clone.arrival_airport_name;

			clone.picture = {};
			clone.picture.file = clone.review_picture_file;

			clone.validation = {};
			clone.validation.flightInfo = !!(clone.departure_date && clone.departureAirport.id && clone.airline.id && clone.arrivalAirport.id && clone.classe);
			clone.validation.texts = !!(clone.title && clone.text && clone.title.length > 1 && clone.text.length > 150);
			clone.validation.ratings = !!(clone.rate_global > 0 && clone.rate_value > 0);
			clone.validation.pictures = !!clone.picture.file;
			clone.validation.all = clone.validation.flightInfo && clone.validation.texts && clone.validation.ratings && clone.validation.pictures;
			
			// trace(clone.validation);

			delete clone.airline_name;
			delete clone.airline_id;
			delete clone.departure_airport_name;
			delete clone.arrival_airport_name;
			delete clone.departure_airport_id;
			delete clone.arrival_airport_id;
			delete clone.review_picture_file;

			f.deferred.resolve(clone);
		}

		f.run = function(id) {
			f.deferred = $q.defer();
			f.id = id;

			Preferences.db().transaction(queryDB, errorCB);

			return f.deferred.promise;
		}
		return f;
	});	