wtf.factory('DatabaseGetAirlineReviews', function(Preferences, $q) {
  		var f = {};
  		
		function errorCB(err) {
			// console.log("Error processing SQL: "+err.code);
			// console.log(err);

			f.deferred.reject(err);
		}

		function queryDB(tx) {
			var sql = 	'	SELECT '+
	    				'		airline.iata_code AS airline_iata_code, airline.name AS airline_name, '+
	    				'		departure_airport.iata_code AS departure_airport_iata_code, departure_airport.name AS departure_airport_name, '+
	    				'		arrival_airport.iata_code AS arrival_airport_iata_code, arrival_airport.name AS arrival_airport_name, '+
	    				'		review_picture.thumbnail AS review_picture_file, '+
	    				'		airline_review.* '+
	    				'	FROM airline_review airline_review '+
	    				'	LEFT JOIN airline airline '+
	    				'		ON airline.id = airline_review.airline_id '+
	    				'	LEFT JOIN airport departure_airport '+
	    				'		ON departure_airport.id = airline_review.departure_airport_id'+
	    		    	'	LEFT JOIN airport arrival_airport '+
	    				'		ON arrival_airport.id = airline_review.arrival_airport_id'+	
	    				'	LEFT JOIN review_picture review_picture '+
	    				' 		ON review_picture.id = airline_review.favorite_picture_id'+
	    				'	WHERE '+f.options.where+
	    				'	ORDER BY airline_review.departure_date DESC, airline_review.id DESC';		
		    tx.executeSql(sql, [], querySuccess, errorCB);
		}

		function querySuccess(tx, results) {
			var items = [];

			var rows = results.rows;
			var length = rows.length;
			for (var i = 0; i < length; i++) {
				var item = rows.item(i);
				var clone = angular.copy(item);
				
				clone.departureDateJS = mysqlDateToJS(clone.departure_date);

				clone.airline = {};
				clone.airline.id = clone.airline_id;
				clone.airline.iata_code = clone.airline_iata_code;
				clone.airline.name = clone.airline_name;

				clone.departureAirport = {};
				clone.departureAirport.id = clone.departure_airport_id;
				clone.departureAirport.iata_code = clone.departure_airport_iata_code;
				clone.departureAirport.name = clone.departure_airport_name;

				clone.arrivalAirport = {};
				clone.arrivalAirport.id = clone.arrival_airport_id;
				clone.arrivalAirport.iata_code = clone.arrival_airport_iata_code;
				clone.arrivalAirport.name = clone.arrival_airport_name;

				// alert(clone.review_picture_file.length); 

				clone.picture = {};
				clone.picture.file = clone.review_picture_file ? clone.review_picture_file : Preferences.getDefaultImage();

				clone.validation = {};
				clone.validation.flightInfo = !!(clone.departure_date && clone.departureAirport.id && clone.airline.id && clone.arrivalAirport.id && clone.classe);
				clone.validation.texts = !!(clone.title && clone.text && clone.title.length > 1 && clone.text.length > 150);
				clone.validation.ratings = !!(clone.rate_global > 0 && clone.rate_value > 0);
				clone.validation.pictures = !!(clone.review_picture_file);
				clone.validation.all = clone.validation.flightInfo && clone.validation.texts && clone.validation.ratings && clone.validation.pictures;

				delete clone.airline_iata_code;
				delete clone.airline_name;
				delete clone.departure_airport_name;
				delete clone.arrival_airport_name;
				delete clone.airline_id;
				delete clone.departure_airport_iata_code;
				delete clone.arrival_airport_iata_code;
				delete clone.departure_airport_id;
				delete clone.arrival_airport_id;
				delete clone.review_picture_file;

				items.push(clone);
			}
			
			f.deferred.resolve(items);
		}

		f.run = function(options) {
			f.deferred = $q.defer();
			f.options = options;

			Preferences.db().transaction(queryDB, errorCB);
			
			return f.deferred.promise;
		}
		return f;
	});	