wtf.factory('PublishAirlineReview', function(Preferences, DatabaseGetReviewPictures, DatabaseUpdateReviewPicture, DatabaseGetRawAirlineReview, DatabaseUpdateAirlineReview, $http, $timeout, $q) {
  		var f = {};

  		function getRawItem() {
  			DatabaseGetRawAirlineReview.run(f.item.id).then(function(item) {
  				f.rawItem = item;
  				setLoadStatus();
  			});
  		}

  		function setLoadStatus() {
  			// trace('setLoadStatus');
  			if (f.item.status == 3) { // done
  				f.deferred.resolve();
  			} else if (f.item.status == 0 || f.item.status == 2 || f.item.status == 1) { // nothing done
	  			if (Preferences.hasInternetConnection()) {
	  				DatabaseUpdateAirlineReview.run(f.item.id, {status: 2}).then(function() {
              f.item.status = 2;
	  					sendToPlateform();
	  				});
	  			} else {
	  				DatabaseUpdateAirlineReview.run(f.item.id, {status: 1}).then(function() {
              f.item.status = 1;
	  					f.deferred.resolve();
	  				});
	  			}
	  		} else if (f.item.status == 4) { // treate picture
	  			sendPictures();
	  		}
  		}

  		function sendToPlateform() {
  			// trace('sendToPlateform '+Preferences.getServiceUrl('airline-reviews/publish'));

  			var sent = Preferences.getServiceConfig(f.rawItem);
  			delete sent.id;


  			$http.post(Preferences.getServiceUrl('airline-reviews/publish'), sent).
			    success(function(data, status, headers, config) {
            // trace(data);
			    	if (data.success) {
				    	f.item.plateform_id = data.data.id;
              
				    	DatabaseUpdateAirlineReview.run(f.item.id, {plateform_id: f.item.plateform_id, status: 4}).then(function() {
                f.item.status = 4;
				    		sendPictures();
		  				});
				    	
			    	} else {
			    		DatabaseUpdateAirlineReview.run(f.item.id, {status: 1}).then(function() {
                f.item.status = 1;
		  					f.deferred.resolve();
		  				});
			    	} 
			    }).
			    error(function(data, status, headers, config) {
              DatabaseUpdateAirlineReview.run(f.item.id, {status: 1}).then(function() {
                f.item.status = 1;
                f.deferred.resolve();
              });
			    });
  		}

  		function sendPictures() {
  			var o = {};
  			o.where = 'review_picture.status = 0';
  			o.order = 'display_order DESC, id ASC';

  			DatabaseGetReviewPictures.runForAirlineReview(f.item, o).then(function(items) {
  				f.pictureLen = items.length;
  				f.pictureIndex = 0;
  				f.toDoPictures = items;

  				sendNextPicture();
  			});
  		}

  		function sendNextPicture() {
  			var pList = f.toDoPictures.splice(0, 1);
  			var p = pList[0];

  			f.pictureIndex++;
  			if (!p) {
  				setUploadedStatus();
  				return;
  			}

  			f.deferred.notify('Photo '+f.pictureIndex+'/'+f.pictureLen);

  			p.related_id = f.item.plateform_id;
  			if (!p.description) {
  				p.description = '';
  			}

        //alert(p['file'].length);

        // for (var k in p) {
        //    alert(k );
        // }

  			$http.post(Preferences.getServiceUrl('review-pictures/publish'), Preferences.getServiceConfig(p)).
			    success(function(data, status, headers, config) {
			    	if (data.success) {

			    		DatabaseUpdateReviewPicture.run(p.id, {status: 1, plateform_id: data.data.id}).then(function() {
			    			sendNextPicture();
			    		});
			    	} else {

              //alert(data.log[0]);
			    		f.deferred.reject();
			    	} 
			    }).
			    error(function(data, status, headers, config) {

			      	f.deferred.reject(data);
			    });
  		}


  		function setUploadedStatus() {
        f.item.status = 3;
  			DatabaseUpdateAirlineReview.run(f.item.id, {status: 3}).then(function() {
				  f.deferred.resolve();
			 });
  		}

		f.run = function(item) {
			f.deferred = $q.defer();
			f.item= item;
      $timeout(function() {
          f.deferred.notify(Preferences.translate('PUBLISHING_LOADING'));
      }, 100);

      getRawItem();

			return f.deferred.promise;
		}
		return f;
	});	