wtf.factory('DatabaseGetAirports', function(Preferences, $q) {
  		var f = {};
  		f.items = undefined;

  		f.options = {pageNum: 1, perPage: 20, q: ''};
  		f.perPage = 20;

		function errorCB(err) {
			// console.log("Error processing SQL: "+err.code);
			// console.log(err);

			f.deferred.reject(err);
		}

		f.run = function(options) {
			f.deferred = $q.defer();
			f.options = options;
		
			Preferences.db().transaction(queryDB, errorCB);	

			return f.deferred.promise;
  		}

  		function queryDB(tx) {
  			var options = [];
			var limit = ((f.options.pageNum - 1) * f.options.perPage)+', '+f.options.perPage
			var where = '1';
			if (f.options.q) {
				where = 'name LIKE ? OR iata_code LIKE ? OR oaci_code LIKE ?';
				options = ['%'+f.options.q+'%', '%'+f.options.q+'%', '%'+f.options.q+'%'];
			}


		    tx.executeSql('SELECT * FROM airport WHERE '+where+' ORDER BY importance DESC LIMIT '+limit, options, querySuccess, errorCB);
		}

		function querySuccess(tx, results) {
			var len = results.rows.length;
		    f.items = [];

		    for (var i=0; i<len; i++){
		    	f.items.push(results.rows.item(i));
		    }

		    f.deferred.resolve(f.items);
		}
		return f;
	});	