wtf.factory('DatabaseGetPreferences', function(DatabaseInit, $q) {
  		var f = {};
  		
		function errorCB(err) {
			// console.log("Error processing SQL: "+err.code);
			// console.log(err);

			f.deferred.reject(err);
		}

		function queryDB(tx) {
			var sql = 	'	SELECT '+
	    				'		preference.* '+
	    				'	FROM preference preference ';		
		    tx.executeSql(sql, [], querySuccess, errorCB);
		}

		function querySuccess(tx, results) {
			var indexedItems = {};

			var rows = results.rows;
			var length = rows.length;
			for (var i = 0; i < length; i++) {
				var item = rows.item(i);

				indexedItems[item.key] = item.value;
			}

			f.deferred.resolve(indexedItems);
		}

		f.run = function() {
			f.deferred = $q.defer();
			
			DatabaseInit.run().then(function(db) {
				db.transaction(queryDB, errorCB);
			});

			return f.deferred.promise;
		}
		return f;
	});	