wtf.factory('DatabaseSetPreference', function(DatabaseInit, $q) {
  		var f = {};
  		
		function errorCB(err) {
			// console.log("Error processing SQL: "+err.code);
			// console.log(err);

			f.deferred.reject(err);
		}

		function queryDB(tx) {
			var sql = 	'	REPLACE INTO preference (`key`, `value`) VALUES (?, ?)';
		    tx.executeSql(sql, [f.key, f.value], querySuccess, errorCB);
		}

		function querySuccess(tx, results) {
			f.deferred.resolve();
		}

		f.run = function(key, value) {
			f.deferred = $q.defer();
			f.key = key;
			f.value = value;

			DatabaseInit.run().then(function(db) {
				db.transaction(queryDB, errorCB);
			});

			return f.deferred.promise;
		}
		return f;
	});	
	