wtf.factory('DatabaseGetReviewPicture', function(Preferences, $q) {
  		var f = {};
  		
		function errorCB(err) {
			// console.log("Error processing SQL: "+err.code);
			// console.log(err);

			f.deferred.reject(err);
		}

		function queryDB(tx) {
			var sql = 	'	SELECT '+
	    				'		review_picture.* '+
	    				'	FROM review_picture review_picture '+
	    				' 	WHERE review_picture.id = ?';		
		    
		    tx.executeSql(sql, [f.id], querySuccess, errorCB);
		}

		function querySuccess(tx, results) {
			var item = results.rows.item(0);
			var clone = angular.copy(item);
			if (!clone.file) {
				clone.file = Preferences.getDefaultImage();
			}

			f.deferred.resolve(clone);
		}

		f.run = function(id) {
			f.deferred = $q.defer();
			f.id = id;

			Preferences.db().transaction(queryDB, errorCB);

			return f.deferred.promise;
		}
		return f;
	});	