wtf.factory('DatabaseGetReviewPictures', function(Preferences, $q) {
  		var f = {};
  		
		function errorCB(err) {
			// console.log("Error processing SQL: "+err.code);
			// console.log(err);

			f.deferred.reject(err);
		}

		function queryDB(tx) {
			var order = (f.options && f.options.order ? f.options.order : 'display_order ASC, id DESC')
			var includeAll = (f.options && f.options.includeAll ? f.options.includeAll : true);

			var select = 'review_picture.*, datetime(review_picture.creation_date, \'localtime\') AS creation_date'
			if (!includeAll) {
				select = 'review_picture.id, review_picture.thumbnail, review_picture.description, datetime(review_picture.creation_date, \'localtime\') AS creation_date';
			}


			var sql = 	'	SELECT '+
	    				'		review_picture.* '+
	    				'	FROM review_picture review_picture '+
	    				' 	WHERE review_picture.related_id = ? AND review_picture.related_table = ? AND ' +(f.options && f.options.where ? f.options.where : '1') +
	    				'	ORDER BY '+order;		
		    
		    tx.executeSql(sql, [f.item.id, f.type], querySuccess, errorCB);
		}

		function querySuccess(tx, results) {
			var items = [];

			var rows = results.rows;
			var length = rows.length;
			for (var i = 0; i < length; i++) {
				var item = rows.item(i);
				var clone = angular.copy(item);
				if (!clone.file) clone.file = Preferences.getDefaultImage();

				clone.creationDateJs = mysqlDateToJS(clone.creation_date_local);
				clone.descriptionHtml = clone.description ? clone.description.replace(/\n/g, '<br />') : '';

				items.push(clone);
			}

			f.deferred.resolve(items);
		}

		f.runForAirlineReview = function(item, options) {
			f.deferred = $q.defer();
			f.type = 'airline_review';
			f.item = item;
			f.options = options;

			Preferences.db().transaction(queryDB, errorCB);

			return f.deferred.promise;
		}
		return f;
	});	