wtf.factory('TakePicture', function($q, DatabaseCreateReviewPicture) {
  		var f = {};

  		function onSuccess(imageData) {
			var o = {};
			o.file = imageData;
			o.related_id = f.id;
			o.related_table = 'airline_review';

			var img = new Image();
			img.src = 'data:image/jpeg;base64,'+imageData;
			document.body.appendChild(img);

			img.onload = function () {
				var width = img.width;
	           	var height = img.height;

	            var newHeight = 160;
	            var newWidth = Math.floor(width / height * newHeight);

	            var canvas = document.createElement('canvas');
				var ctx = canvas.getContext("2d");

		        canvas.width = newWidth;
		        canvas.height = newHeight;

	        	ctx.drawImage(img, 0, 0, newWidth, newHeight);

	        	o.thumbnail = canvas.toDataURL("image/jpeg", 0.5);

	        	document.body.removeChild(img);

	        	DatabaseCreateReviewPicture.run(o).then(function(item) {
					f.deferred.resolve(item);
				});
	        }
		}

		function onFail(message) {
		    // trace('Failed because: ' + message);
		    f.deferred.reject(message);
		}

		f.run = function(id, from) {
			f.deferred = $q.defer();
			f.id = id;

			navigator.camera.getPicture(onSuccess, onFail, { 
				sourceType: from == 'camera' ? Camera.PictureSourceType.CAMERA : Camera.PictureSourceType.PHOTOLIBRARY,
				quality: 90,
			    destinationType: Camera.DestinationType.DATA_URL,
			    correctOrientation: true,
			    allowEdit: false,
			    mediaType: Camera.MediaType.PICTURE,
			    encodingType: Camera.EncodingType.JPEG,
			    targetWidth: 1024,
	 		 	targetHeight: -1,
	 		 	saveToPhotoAlbum: false
			});

			return f.deferred.promise;
		}
		return f;
	});	